<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: Show User Info in Forums Infusion
| Filename: show_userinfo_forum_panel.php
| Author: Ankur Thakur
| Version: 1.00
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

require_once INCLUDES."infusions_include.php";

// Folder
$sui_folder = "show_userinfo_forum_panel";

// Get the Main Settings of Infusion like Width and Enabled or not
$sui_mainsettings = get_settings($sui_folder."_setting");

// Get The Userfields from the SETTINGS_INF Table
$sui_result = dbquery("SELECT sf.settings_name, sf.settings_value FROM ".DB_SETTINGS_INF." sf LEFT JOIN ".DB_USER_FIELDS." uf ON sf.settings_name=uf.field_name WHERE sf.settings_inf='".$sui_folder."' ORDER BY uf.field_order DESC");

$sui_settings = array();
while ($data = dbarray($sui_result))
{
	$sui_settings[$data['settings_name']] = $data['settings_value'];
}

// Check if current page is viewthread.php and the infusion is enabled or not
if((FUSION_SELF == 'viewthread.php') && ($sui_mainsettings['sui_enabled'] == "1"))
{

// Style for the Text in the Userfield area
add_to_head("<style type='text/css'>
.showuserdataforum
{
	/* Apply whatever CSS you want in User Details here below */
	font-weight: bold;
	font-size: 11px;
}
</style>");

// Global Variables

// Array which will store authors which have posted to a particular thread
// The authors are grouped so that they don't call function 10 times for 2 Authors (2x10=20 posts) posting in a same thread
$authors_grouped = array();

// Array to Store the User data for all the users who have posted on the thread
$alluserdata = array();

// The Enabled User fields
$fields = array();

// Adding Enabled User Field into array

foreach ($sui_settings as $key => $value)
{
	if($value == "1")
	{
		$fields[] = $key;
	}
}

function sui_change($output)
{
	global $authors_grouped, $fields, $alluserdata;

	$posts = dbquery("SELECT post_author FROM ".DB_POSTS." WHERE thread_id='".stripinput($_GET['thread_id'])."' ORDER BY post_datestamp LIMIT ".stripinput($_GET['rowstart']).",20");

	while ($data = dbarray($posts))
   {
   	// Grouping Authors by their IDs
   	if (!in_array($data['post_author'], $authors_grouped))
		{
			$authors_grouped[] = $data['post_author'];
		}

		// Changing Comment
		$output = preg_replace("/<!--forum_thread_user_info-->/", "<!--forum_thread_user_".$data['post_author']."_info-->", $output, 1);
	}

	// Selecting the USER Info
	$datauser = dbquery("SELECT * FROM ".DB_USERS." WHERE user_id".(count($authors_grouped) > 1 ? " IN (".implode(',', $authors_grouped).")" : "=".implode(',', $authors_grouped)));
	while ($data = dbarray($datauser))
	{
		$alluserdata[$data['user_id']] = array();
		foreach ($fields as $key => $value)
		{
			if (!preg_match("/(.*?)\-stat/", $value))
			{
				$alluserdata[$data['user_id']][$value] = $data[$value];
			}
			else
			{
				// Exception for Statistical Userfields like Comments Posted, there doesn't exist any column in USERS Table, so fill with empty space
				$alluserdata[$data['user_id']][$value] = "";
			}
		}
		// Exception for Statistical Userfields like Comments Posted, we need the user_id
		$alluserdata[$data['user_id']]['user_id'] = $data['user_id'];
		// For Forum Posts
		$alluserdata[$data['user_id']]['user_posts'] = $data['user_posts'];
	}

	return $output;
}
// Handler for Replacing comment and make it unique with format : <!--forum_thread_user_ID_info-->
add_handler("sui_change");

function showuserdatainforum($user_id)
{
	global $locale, $alluserdata, $fields, $sui_mainsettings;

	// Set the profile method to Display for User Field rendering
	$profile_method = "display";
	
	// Get the Userdata from $alluserdata array for a particular $user_id
	$user_data = $alluserdata[$user_id];
	$res = "<table cellpadding='0' cellspacing='0' class='showuserdataforum' width='".($sui_mainsettings['sui_width'] ? $sui_mainsettings['sui_width'] : "180")."' style='text-align:left;float:left;table-layout:fixed;'>\n";

	ob_start();

	// Include each User Field for every enabled User Field
	foreach ($fields as $key => $value)
	{
		if (file_exists(LOCALE.LOCALESET."user_fields/".$value.".php"))
		{
			include LOCALE.LOCALESET."user_fields/".$value.".php";
		}
		if (file_exists(INCLUDES."user_fields/".$value."_include.php"))
		{
			include INCLUDES."user_fields/".$value."_include.php";
		}
	}
	$res.= ob_get_contents();
	ob_end_clean();

	$res .= "</table>\n";

	return $res;
}

function sui_replace($output)
{
	global $authors_grouped;

	for ($i=0; $i < count($authors_grouped); $i++)
	{
		$output = preg_replace("/<!--forum_thread_user_".$authors_grouped[$i]."_info-->/", "<!--forum_thread_user_info-->\n<!-- Show User Info in Forums Infusion v1.00 - By Ankur Thakur | Visit http://ankurthakur.in/ for more -->\n".showuserdatainforum($authors_grouped[$i]), $output);
	}
	return $output;
}
// Handler for Changing the output on the Comments
add_handler("sui_replace");

}

?>