<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: Show User Info in Forums Infusion
| Filename: show_userinfo_forum_panel_admin.php
| Author: Ankur Thakur
| Version: 1.00
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
include LOCALE.LOCALESET."admin/settings.php";
require_once INCLUDES."infusions_include.php";

if (!checkrights("SUI")||!defined("iAUTH")||$_GET['aid']!=iAUTH) { redirect("../index.php"); }

if (file_exists(INFUSIONS."show_userinfo_forum_panel/locale/".$settings['locale'].".php")) {
   include INFUSIONS."show_userinfo_forum_panel/locale/".$settings['locale'].".php";
     } else {
   include INFUSIONS."show_userinfo_forum_panel/locale/English.php"; 
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Creating Info for Errors
if (isset($_GET['error']) && isnum($_GET['error'])) {
	if ($_GET['error'] == 1) {
		$message = $locale['901'];
	}
	if ($_GET['error'] == 2) {
		$message = $locale['900'];
	}
	if (isset($message)) {
		echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n";
	}
}

// Main Settings
$sui_mainsettings = get_settings("show_userinfo_forum_panel_setting");

// Get The Infusion Settings
$sui_update_settings = get_settings("show_userinfo_forum_panel");

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Infusion Settings Query
if (isset($_POST['saveinfusionsettings']))
{
	$error = 0;
	// Post parameter array for Enabled Userfields using CHECKBOXES
	if (isset($_POST['enabled_uf']) && is_array($_POST['enabled_uf']) && count($_POST['enabled_uf']))
	{
		$enabled = "";
		$to_add = array();

		foreach ($_POST['enabled_uf'] as $enabled_name)
		{
			if(!array_key_exists($enabled_name, $sui_update_settings))
			{
				// If the Userfield doesn't exist in SETTINGS_INF Table, then add it
				$to_add[] = $enabled_name;
			}
			else
			{
				// If User field already exists, then we willl be going to update its value
				$enabled .= ($enabled ? "," : "")."'".$enabled_name."'";
			}
		}
		// It will enable the Existing Fields
		if ($enabled)
		{
			$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='1' WHERE settings_name IN (".$enabled.") AND settings_inf='show_userinfo_forum_panel'");
			if (!$result) {	$error = 1;	}
			$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='0' WHERE settings_name NOT IN (".$enabled.") AND settings_inf='show_userinfo_forum_panel'");
			if (!$result) {	$error = 1;	}
		}
		// It will add new fields to show in SETTINGS_INF Table if it already doesn't exist
		if (!empty($to_add))
		{
			foreach ($to_add as $addname)
			{
				$result = dbquery("INSERT INTO ".DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('".$addname."', '1', 'show_userinfo_forum_panel')");
				if (!$result) {	$error = 1;	}
			}
		}
	}
	if (isset($_POST['sui_enabled']) && isNum($_POST['sui_enabled']) && isset($_POST['sui_width']) && isNum($_POST['sui_enabled']))
	{
			$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='".$_POST['sui_enabled']."' WHERE settings_name='sui_enabled' AND settings_inf='show_userinfo_forum_panel_setting'");
			if (!$result) {	$error = 1;	}
			$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='".$_POST['sui_width']."' WHERE settings_name='sui_width' AND settings_inf='show_userinfo_forum_panel_setting'");
			if (!$result) {	$error = 1;	}
	}
	if ($error == 1)
	{
		redirect(FUSION_SELF.$aidlink."&error=1");
	}
	else
	{
		redirect(FUSION_SELF.$aidlink."&error=2");
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Get The Infusion Settings
$suisettings = get_settings("show_userinfo_forum_panel");

// Select the User fields according to their Order
$userfields = dbquery("SELECT field_name FROM ".DB_USER_FIELDS." ORDER BY field_order DESC");
$fields = array();

while ($data = dbarray($userfields))
{
	$fields[] = $data['field_name'];
}

opentable($locale['admin_title']);

echo "<form name='infusion_settings' method='post' action='".FUSION_SELF.$aidlink."'>\n";

echo "<center>\n";

// Main Settings
echo "<h2>".$locale['sui_001']."</h2>\n";
echo "<table cellpadding='0' cellspacing='0'>\n";

echo "<tr>\n";
echo "<td class='tbl2'><b>".$locale['sui_002']."</b></td>\n";
echo "<td class='tbl2'>";
echo "<select name='sui_enabled' class='textbox'>";
echo "<option value='0'".($sui_mainsettings['sui_enabled'] == 0 ? "selected='selected'" : "").">".$locale['sui_no']."</option>\n";
echo "<option value='1'".($sui_mainsettings['sui_enabled'] == 1 ? "selected='selected'" : "").">".$locale['sui_yes']."</option>\n";
echo "</select>";
echo "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "<td class='tbl2'><b>".$locale['sui_003']."</b></td>\n";
echo "<td class='tbl2'><input type='text' name='sui_width' value='".($sui_mainsettings['sui_width'] ? $sui_mainsettings['sui_width'] : "180")."' class='textbox' size='40' /></td>\n";
echo "</tr>\n";

echo "</table>\n<br />";

// User Fields
echo "<h2>".$locale['sui_004']."</h2>\n";
echo "<table cellpadding='0' cellspacing='0'>\n";
echo "<tr>\n";
echo "<td class='tbl2'><b>".$locale['sui_005']."</b></td>\n";
echo "<td class='tbl2'><b>".$locale['sui_006']."</b></td>\n";
echo "<td class='tbl2'><b>".$locale['sui_007']."</b></td>\n";
echo "</tr>\n";

// For each Userfield, include them
foreach ($fields as $key => $value)
{
	if (file_exists(LOCALE.LOCALESET."user_fields/".$value.".php"))
	{
		include LOCALE.LOCALESET."user_fields/".$value.".php";
	}
	if (file_exists(INCLUDES."user_fields/".$value."_include_var.php"))
	{
		include INCLUDES."user_fields/".$value."_include_var.php";
	}

	echo "<tr>\n";
	echo "<td class='tbl2'><b>".$user_field_name."</b></td>\n";
	echo "<td class='tbl2'>";
	// Check if Userfield is already in SETTINGS_INF table, then check its value, i.e 0 or 1
	if(array_key_exists($value, $suisettings))
	{
		echo "<input type='checkbox' name='enabled_uf[]' value='".$value."'".($suisettings[$value] == 1 ? " checked='yes'" : "")." />";
	}
	else
	{
		// If its a new userfield, which is not added yet, then just show it to add.
		echo "<input type='checkbox' name='enabled_uf[]' value='".$value."' />";
	}
	echo "</td>\n";
	echo "<td class='tbl2'>".$user_field_desc."</td>\n";
	echo "</tr>\n";
}

echo "<tr>\n";
echo "<td class='tbl2'></td>\n";
echo "<td class='tbl2'><input type='submit' name='saveinfusionsettings' value='".$locale['sui_008']."' class='button' /></td>\n";
echo "</tr>\n";

echo "</table>\n</center>\n</form>\n";

echo "<br />\n<div class='admin-message'><a href='http://ankurthakur.in/' target='_blank'><b>Show User Info in Forums Infusion v1.00 &copy; Ankur Thakur 2012</b></a></div>\n";

closetable();

require_once THEMES."templates/footer.php";
?>